<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::sequence_kernel_2&lt; T, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1sequence__kernel__2-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::sequence_kernel_2&lt; T, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::sequence_kernel_2&lt; T, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1sequence__kernel__2.png" usemap="#dlib::sequence_5Fkernel_5F2_3C_20T_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::sequence_5Fkernel_5F2_3C_20T_2C_20mem_5Fmanager_20_3E_map" name="dlib::sequence_5Fkernel_5F2_3C_20T_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; T &gt;" shape="rect" coords="0,0,269,24"/>
<area href="classdlib_1_1remover.html" alt="dlib::remover&lt; T &gt;" shape="rect" coords="279,0,548,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a80f8f05debe7895331b2ed855835719e"><td class="memItemLeft" align="right" valign="top"><a id="a80f8f05debe7895331b2ed855835719e"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>type</b></td></tr>
<tr class="separator:a80f8f05debe7895331b2ed855835719e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37fd6e980bb32339a60e243b882b93c7"><td class="memItemLeft" align="right" valign="top"><a id="a37fd6e980bb32339a60e243b882b93c7"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:a37fd6e980bb32339a60e243b882b93c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td></tr>
<tr class="separator:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a30cd8037aed3ca3278ee8d1edabd4588"><td class="memItemLeft" align="right" valign="top"><a id="a30cd8037aed3ca3278ee8d1edabd4588"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a30cd8037aed3ca3278ee8d1edabd4588"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3169d993a4c94b4ad38f6a44132541c"><td class="memItemLeft" align="right" valign="top"><a id="ac3169d993a4c94b4ad38f6a44132541c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add</b> (unsigned long pos, T &amp;item)</td></tr>
<tr class="separator:ac3169d993a4c94b4ad38f6a44132541c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad21289262bc4928e49cb553b427fc22c"><td class="memItemLeft" align="right" valign="top"><a id="ad21289262bc4928e49cb553b427fc22c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove</b> (unsigned long pos, T &amp;item)</td></tr>
<tr class="separator:ad21289262bc4928e49cb553b427fc22c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a743231ec8790400a74ca7e645bbc3a4d"><td class="memItemLeft" align="right" valign="top"><a id="a743231ec8790400a74ca7e645bbc3a4d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>cat</b> (<a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a> &amp;item)</td></tr>
<tr class="separator:a743231ec8790400a74ca7e645bbc3a4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6da854b62dd75674bb77ef9d1a4b8ef2"><td class="memItemLeft" align="right" valign="top"><a id="a6da854b62dd75674bb77ef9d1a4b8ef2"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (unsigned long pos) const</td></tr>
<tr class="separator:a6da854b62dd75674bb77ef9d1a4b8ef2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9917db116d0540de19aed84b0f4789f9"><td class="memItemLeft" align="right" valign="top"><a id="a9917db116d0540de19aed84b0f4789f9"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (unsigned long pos)</td></tr>
<tr class="separator:a9917db116d0540de19aed84b0f4789f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed897682cdb6d65319c2b168e591ffac"><td class="memItemLeft" align="right" valign="top"><a id="aed897682cdb6d65319c2b168e591ffac"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a> &amp;item)</td></tr>
<tr class="separator:aed897682cdb6d65319c2b168e591ffac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af2d447a6c81f63e6e8eb49a552f5e4d6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#af2d447a6c81f63e6e8eb49a552f5e4d6">remove_any</a> (T &amp;item)</td></tr>
<tr class="separator:af2d447a6c81f63e6e8eb49a552f5e4d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae98fda96492e8bb9423d6cae4183e86b"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#ae98fda96492e8bb9423d6cae4183e86b">size</a> () const</td></tr>
<tr class="separator:ae98fda96492e8bb9423d6cae4183e86b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d7616c783c811e265ce4216ee20526f"><td class="memItemLeft" align="right" valign="top"><a id="a5d7616c783c811e265ce4216ee20526f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a5d7616c783c811e265ce4216ee20526f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e1a173f6b22ce10abef612e96280a1d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a1e1a173f6b22ce10abef612e96280a1d">reset</a> () const</td></tr>
<tr class="separator:a1e1a173f6b22ce10abef612e96280a1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac877be06b8bc26299ec520c60908b09a"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#ac877be06b8bc26299ec520c60908b09a">current_element_valid</a> () const</td></tr>
<tr class="separator:ac877be06b8bc26299ec520c60908b09a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ceef7acad65a8aebdcfeb18853e2c3c"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a8ceef7acad65a8aebdcfeb18853e2c3c">element</a> () const</td></tr>
<tr class="separator:a8ceef7acad65a8aebdcfeb18853e2c3c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a051e0c29f90715a3c824fa1fd99dcd0a"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a051e0c29f90715a3c824fa1fd99dcd0a">element</a> ()</td></tr>
<tr class="separator:a051e0c29f90715a3c824fa1fd99dcd0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d76f8dcfaa8ae3c334ca19218febb89"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a7d76f8dcfaa8ae3c334ca19218febb89">move_next</a> () const</td></tr>
<tr class="separator:a7d76f8dcfaa8ae3c334ca19218febb89"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:acd1588235a3f8569263cae634f419c57"><td class="memItemLeft" align="right" valign="top"><a id="acd1588235a3f8569263cae634f419c57"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>delete_nodes</b> (<a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a> *current_node, unsigned long <a class="el" href="classdlib_1_1sequence__kernel__2.html#a911fa42978b9e733135639a744d12a59">sequence_size</a>)</td></tr>
<tr class="separator:acd1588235a3f8569263cae634f419c57"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a366be6be40b3eb67c54c6197e33dd897"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a366be6be40b3eb67c54c6197e33dd897">move_to_pos</a> (<a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a> *&amp;current_node, unsigned long &amp;current_pos, unsigned long pos, unsigned long <a class="el" href="classdlib_1_1sequence__kernel__2.html#ae98fda96492e8bb9423d6cae4183e86b">size</a>) const</td></tr>
<tr class="separator:a366be6be40b3eb67c54c6197e33dd897"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29a4faa0c1116e04f8c431eae359ce79"><td class="memItemLeft" align="right" valign="top"><a id="a29a4faa0c1116e04f8c431eae359ce79"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>sequence_kernel_2</b> (<a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a29a4faa0c1116e04f8c431eae359ce79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f2b8f6170ca789a567e1811b0960185"><td class="memItemLeft" align="right" valign="top"><a id="a0f2b8f6170ca789a567e1811b0960185"></a>
<a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1sequence__kernel__2.html">sequence_kernel_2</a> &amp;)</td></tr>
<tr class="separator:a0f2b8f6170ca789a567e1811b0960185"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a911fa42978b9e733135639a744d12a59"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1sequence__kernel__2.html#a911fa42978b9e733135639a744d12a59">sequence_size</a></td></tr>
<tr class="separator:a911fa42978b9e733135639a744d12a59"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f82c1540fb96cbc9e99df7b1281b299"><td class="memItemLeft" align="right" valign="top"><a id="a4f82c1540fb96cbc9e99df7b1281b299"></a>
<a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>current_node</b></td></tr>
<tr class="separator:a4f82c1540fb96cbc9e99df7b1281b299"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafc70c8a525ba533d48700eb9eefb7b2"><td class="memItemLeft" align="right" valign="top"><a id="aafc70c8a525ba533d48700eb9eefb7b2"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>current_pos</b></td></tr>
<tr class="separator:aafc70c8a525ba533d48700eb9eefb7b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45311a413de0dbc0a75137f2107f5626"><td class="memItemLeft" align="right" valign="top"><a id="a45311a413de0dbc0a75137f2107f5626"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start_</b></td></tr>
<tr class="separator:a45311a413de0dbc0a75137f2107f5626"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59bcad1cde2d95889bd04c955c6294b7"><td class="memItemLeft" align="right" valign="top"><a id="a59bcad1cde2d95889bd04c955c6294b7"></a>
<a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>current_enumeration_node</b></td></tr>
<tr class="separator:a59bcad1cde2d95889bd04c955c6294b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4754a533406ad971d9a7a8aa0dfaf15f"><td class="memItemLeft" align="right" valign="top"><a id="a4754a533406ad971d9a7a8aa0dfaf15f"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>current_enumeration_pos</b></td></tr>
<tr class="separator:a4754a533406ad971d9a7a8aa0dfaf15f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1remover.html">remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a58be6630e553c7f4d14dd4c4c2b4c859">operator=</a> (const <a class="el" href="classdlib_1_1remover.html">remover</a> &amp;)</td></tr>
<tr class="separator:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ac877be06b8bc26299ec520c60908b09a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac877be06b8bc26299ec520c60908b09a">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a051e0c29f90715a3c824fa1fd99dcd0a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a051e0c29f90715a3c824fa1fd99dcd0a">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T &amp; <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a8ceef7acad65a8aebdcfeb18853e2c3c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ceef7acad65a8aebdcfeb18853e2c3c">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a7d76f8dcfaa8ae3c334ca19218febb89"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d76f8dcfaa8ae3c334ca19218febb89">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a366be6be40b3eb67c54c6197e33dd897"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a366be6be40b3eb67c54c6197e33dd897">&#9670;&nbsp;</a></span>move_to_pos()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::move_to_pos </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structdlib_1_1sequence__kernel__2_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>current_node</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long &amp;&#160;</td>
          <td class="paramname"><em>current_pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    CONVENTION IS CORRECT
ensures
    all memory associated with the ring of nodes has been freed
</pre><p> ! </p>

</div>
</div>
<a id="af2d447a6c81f63e6e8eb49a552f5e4d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2d447a6c81f63e6e8eb49a552f5e4d6">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">T &amp;&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1remover.html#a80c7e7417e08a66ca361f646a12aaa03">dlib::remover&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a1e1a173f6b22ce10abef612e96280a1d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e1a173f6b22ce10abef612e96280a1d">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ae98fda96492e8bb9423d6cae4183e86b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae98fda96492e8bb9423d6cae4183e86b">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a911fa42978b9e733135639a744d12a59"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a911fa42978b9e733135639a744d12a59">&#9670;&nbsp;</a></span>sequence_size</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename mem_manager = default_memory_manager&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1sequence__kernel__2.html">dlib::sequence_kernel_2</a>&lt; T, mem_manager &gt;::sequence_size</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    everything in the CONVENTION is correct and
    there is a node corresponding to pos in the CONVENTION and
    0 &lt;= pos &lt; size
ensures
    current_pos == pos and
    current_node-&gt;item is the item in the sequence associated with 
    position pos
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="sequence__kernel__2_8h_source.html">sequence_kernel_2.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
